/*        */
#include <config.h>

#define ABS(x)          (x-_start)

#define SELECTOR_CODE           8
#define SELECTOR_VIDEO         16

/*      (i8086) */
.code16

.text
.globl _start

/*
 *       700h,
 *  DL  .   
 *  0:700h.
 *  , 
 * CS = 0
 * IP = 7c00h
 * DL =   (   
 *      BIOS int 13h).
 *
 * :
 * :
 *  cs:ip - 0:7c00h
 *  dl    -  
 * :
 *  00000-003FF        
 *  00400-005FF       BIOS ( 1536 )
 *  00600-07BFF       ( 30208 )
 *  07C00-07DFF         ( 512 )
 *  07E00-9FFFF       ( 623104 )
 *  A0000-FFFFF       BIOS ( 393216 )
 */

/*       */
_start:
	jmp main

msg:	.asciz "Kernel code starting...\n"

/*    */
main:
	cli
	movw $SEG_BOOT_KERNEL, %ax
	movw %ax, %ds           /*            */
	sti

	/*     kernel */
	movw $ABS(msg), %ax
	pushw %ax
	call puts
	addw $2, %sp

	cli
	lgdtw _gdtr

	/*   PM */
	movl %cr0, %eax
	orb $1, %al
	movl %eax, %cr0

	ljmp $SELECTOR_CODE, $entry_PM

.code32
entry_PM:
	movw $SELECTOR_VIDEO, %ax
	movw %ax, %ds

	xorl %eax, %eax
	movw $0x1f41, (%eax)

	movl $3998, %eax
	movw $0x1f41,(%eax)

stop:	jmp stop

_gdtr:
	.word 23
	.long _gdt+0x8000
_gdt:
	.quad 0x0000000000000000
	.quad 0x00c09a0080000000
	.quad 0x0040920b80000f9f
